---
title: Navigator.requestMediaKeySystemAccess()
slug: Web/API/Navigator/requestMediaKeySystemAccess
tags:
  - API
  - Audio
  - DOM Reference
  - EME
  - Encrypted Media Extensions
  - Encrypted Media Extensions API
  - HTML DOM
  - Method
  - Navigator
  - Reference
  - Video
  - requestMediaKeySystemAccess
---
<div>{{APIRef("Encrypted Media Extensions")}}</div>

<p>The <strong><code>Navigator.requestMediaKeySystemAccess()</code></strong> method returns a {{jsxref('Promise')}} which delivers a {{domxref('MediaKeySystemAccess')}} object that can be used to access a particular media key system, which can in turn be used to create keys for decrypting a media stream. This method is part of the <a href="/en-US/docs/Web/API/Encrypted_Media_Extensions_API">Encrypted Media Extensions API</a>, which brings support for encrypted media and DRM-protected video to the web.</p>

<p>This method may have user-visible effects such as asking for permission to access one or more system resources. Consider that when deciding when to call <code>requestMediaKeySystemAccess</code><code>()</code>; you don't want those requests to happen at inconvenient times. As a general rule, this function should be called only when it's about time to create and use a {{domxref("MediaKeys")}} object by calling the returned {{domxref("MediaKeySystemAccess")}} object's {{domxref("MediaKeySystemAccess.createMediaKeys", "createMediaKeys()")}} method.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>Promise</em> = Navigator.requestMediaKeySystemAccess(<em>keySystem</em>, <em>supportedConfigurations</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>keySystem</code></dt>
 <dd>A {{domxref('DOMString')}} identifying the key system. For example <code>com.example.somesystem</code> or <code>org.w3.clearkey</code>.</dd>
 <dt><code>supportedConfigurations</code></dt>
 <dd>A non-empty {{jsxref('Array')}} of {{domxref('MediaKeySystemConfiguration')}} objects. The first element with a satisfiable configuration will be used.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Promise')}} that, when resolved, delivers a {{domxref('MediaKeySystemAccess')}} object to your fulfillment handler function. The fulfillment handler receives as input just one parameter:</p>

<dl>
 <dt><code>mediaKeySystemAccess</code></dt>
 <dd>A {{domxref("MediaKeySystemAccess")}} object representing the media key system configuration described by <code>keySystem</code> and <code>supportedConfigurations</code></dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<p>In case of an error, the returned {{jsxref('Promise')}} is rejected with a {{domxref('DOMException')}} whose name indicates what kind of error occurred.</p>

<dl>
 <dt><code>NotSupportedError</code></dt>
 <dd>Either the specified <code>keySystem</code> isn't supported by the platform or the browser, or none of the configurations specified by <code>supportedConfigurations</code> can be satisfied (if, for example, none of the <code>codecs</code> specified in <code>contentType</code> are available).</dd>
 <dt><code>TypeError</code></dt>
 <dd>Either <code>keySystem</code> is an empty string or the <code>supportedConfigurations</code> array is empty.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('EME', '#navigator-extension-requestmediakeysystemaccess', 'requestMediaKeySystemAccess()')}}</td>
   <td>{{Spec2('EME')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Navigator.requestMediaKeySystemAccess")}}</p>

<h3 id="Firefox_compatibility_notes">Firefox compatibility notes</h3>

<p>Firefox 55 outputs a warning to the console if a candidate {{domxref("MediaKeySystemConfiguration")}} included in <code>supportedConfigurations</code> includes an <code>audioCapabilities</code> or <code>videoCapabilities</code> object whose value of <code>contentType</code> doesn't specify a <code>"codecs"</code> substring defining which codecs within the media wrapper format should be allowed.</p>

<p>For example:</p>

<pre class="example-bad brush: js highlight[5,8]">let clearKeyOptions = [
  {
    initDataTypes: ['keyids', 'webm'],
    audioCapabilities: [
      { contentType: 'audio/webm' }
    ],
    videoCapabilities: [
      { contentType: 'video/webm' }
    ]
  }
];

navigator.requestMediaKeySystemAccess('org.w3.clearkey', clearKeyOptions)
.then(function(keySystemAccess) {
  /* use the access to get create keys */
});</pre>

<p>The code above works in Firefox up to version 55, but version 55 onwards will output a warning to console, because <code>"codecs"</code> is not included in the <code>contentType</code> strings. This could be corrected as follows:</p>

<pre class="example-good brush: js highlight[5-6,9-10]">let clearKeyOptions = [
  {
    initDataTypes: ['keyids', 'webm'],
    audioCapabilities: [
      { contentType: 'audio/webm; codecs="opus"' },
      { contentType: 'audio/webm; codecs="vorbis"' }
    ],
    videoCapabilities: [
      { contentType: 'video/webm; codecs="vp9"' },
      { contentType: 'video/webm; codecs="vp8"' }
    ]
  }
];

navigator.requestMediaKeySystemAccess('org.w3.clearkey', clearKeyOptions)
.then(function(keySystemAccess) {
  /* use the access to get create keys */
});</pre>

<p>In this revised example, the audio and video capabilities include possible codecs which should be permitted, and therefore are valid requests.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Encrypted_Media_Extensions_API">Encrypted Media Extensions API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
</ul>
